﻿' ----- Microsoft ADO.NET 4.0 Step by Step
'       Sample for Chapter 10 - Visual Basic Version
'       by Tim Patrick

Imports System.Data.SqlClient

Module General
    Public Sub ExecuteSQL(ByVal commandWrapper As SqlCommand)
        ' ----- Execute a SQL statement with no expected return values.
        '       Let the caller handle errors.
        Using linkToDB As SqlConnection = OpenConnection()
            commandWrapper.Connection = linkToDB
            commandWrapper.ExecuteNonQuery()
        End Using
    End Sub

    Public Function ExecuteSQLReturn(ByVal commandWrapper As SqlCommand) As Object
        ' ----- Execute a SQL statement with a scalar return value. Let the
        '       caller handle errors.
        Using linkToDB As SqlConnection = OpenConnection()
            commandWrapper.Connection = linkToDB
            Return commandWrapper.ExecuteScalar()
        End Using
    End Function

    Public Function GetConnectionString() As String
        ' ----- Build a connection string for the active database.
        Dim builder As New SqlConnectionStringBuilder

        builder.DataSource = "(local)\SQLExpress"
        builder.InitialCatalog = "StepSample"
        builder.IntegratedSecurity = True
        Return builder.ConnectionString
    End Function

    Public Function OpenConnection() As SqlConnection
        ' ----- Open a connection to the database.
        Try
            Dim linkToDB As New SqlConnection(GetConnectionString())
            linkToDB.Open()
            Return linkToDB
        Catch ex As Exception
            MessageBox.Show("Database connection failed: " & ex.Message)
            Return Nothing
        End Try
    End Function

    Public Function OpenReader(ByVal sqlText As String,
            ByVal linkToDB As SqlConnection) As SqlDataReader
        ' ----- Open a DataReader for the given SQL statement.
        Try
            Dim commandWrapper As New SqlCommand(sqlText, linkToDB)
            Return commandWrapper.ExecuteReader()
        Catch ex As Exception
            MessageBox.Show("Database query failed: " & ex.Message)
            Return Nothing
        End Try
    End Function
End Module
