﻿' ----- Microsoft ADO.NET 4.0 Step by Step
'       Sample for Chapter 11 - Visual Basic Version
'       by Tim Patrick

Imports System.Data.SqlClient

Public Class UnitEditor
    ' ----- Fields used to monitor the active database content.
    Private UnitAdapter As New SqlDataAdapter
    Private UnitTable As New DataTable

    Private Sub UnitEditor_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' ----- Prepare the form.
        Dim unitCommand As SqlCommand
        Dim linkToDB As SqlConnection

        ' ----- Open the database.
        linkToDB = New SqlConnection(GetConnectionString())

        ' ----- Build the selection query.
        unitCommand = New SqlCommand("SELECT * FROM UnitOfMeasure ORDER BY ID", linkToDB)
        UnitAdapter.SelectCommand = unitCommand

        ' ----- Build the insertion query.
        unitCommand = New SqlCommand("INSERT INTO UnitOfMeasure (ShortName, FullName) " &
            "VALUES (@ShortName, @FullName); SET @ID = @@IDENTITY;", linkToDB)
        unitCommand.Parameters.Add("@ShortName", SqlDbType.VarChar, 15, "ShortName")
        unitCommand.Parameters.Add("@FullName", SqlDbType.VarChar, 50, "FullName")
        With unitCommand.Parameters.Add("@ID", SqlDbType.BigInt, 0, "ID")
            .Direction = ParameterDirection.Output
        End With
        UnitAdapter.InsertCommand = unitCommand

        ' ----- Build the revision query.
        unitCommand = New SqlCommand("UPDATE UnitOfMeasure SET ShortName = @ShortName, " &
            "FullName = @FullName WHERE ID = @ID", linkToDB)
        unitCommand.Parameters.Add("@ShortName", SqlDbType.VarChar, 15, "ShortName")
        unitCommand.Parameters.Add("@FullName", SqlDbType.VarChar, 50, "FullName")
        With unitCommand.Parameters.Add("@ID", SqlDbType.BigInt, 0, "ID")
            .SourceVersion = DataRowVersion.Original
        End With
        UnitAdapter.UpdateCommand = unitCommand

        ' ----- Build the deletion query.
        unitCommand = New SqlCommand("DELETE FROM UnitOfMeasure WHERE ID = @ID", linkToDB)
        With unitCommand.Parameters.Add("@ID", SqlDbType.BigInt, 0, "ID")
            .SourceVersion = DataRowVersion.Original
        End With
        UnitAdapter.DeleteCommand = unitCommand

        ' ----- Load the data from the database into the local editor.
        Try
            UnitAdapter.Fill(UnitTable)
            UnitGrid.DataSource = UnitTable
        Catch ex As Exception
            MessageBox.Show("Error occurred loading records: " & ex.Message)
        End Try
    End Sub

    Private Sub ActUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActUpdate.Click
        ' ----- Send the data back to the database.
        Try
            UnitAdapter.Update(UnitTable)
        Catch ex As Exception
            MessageBox.Show("Error occurred during database update: " & ex.Message)
        End Try
    End Sub

    Public Function GetConnectionString() As String
        ' ----- Build a connection string for the active database.
        Dim builder As New SqlConnectionStringBuilder

        builder.DataSource = "(local)\SQLExpress"
        builder.InitialCatalog = "StepSample"
        builder.IntegratedSecurity = True
        Return builder.ConnectionString
    End Function
End Class
