﻿' ----- Microsoft ADO.NET 4.0 Step by Step
'       Sample for Chapter 16 - Visual Basic Version
'       by Tim Patrick

Public Class ItemData
    ' ----- Class used to support ListBox and ComboBox items.
    Public ItemText As String
    Public ItemValue As Long

    Public Sub New(ByVal newText As String, ByVal newData As Long)
        ' ----- Required constructor.
        Me.ItemText = newText
        Me.ItemValue = newData
    End Sub

    Public Overrides Function ToString() As String
        ' ----- Show the text in ListBox and ComboBox displays.
        Return Me.ItemText
    End Function

    Public Overrides Function Equals(ByVal obj As Object) As Boolean
        ' ----- Allow IndexOf() and Contains() searches by ItemValue.
        If (TypeOf obj Is Long) Then
            Return CBool(CLng(obj) = Me.ItemValue)
        Else
            Return MyBase.Equals(obj)
        End If
    End Function

    Public Shared Function GetItemData(ByVal whichRecord As Object) As Long
        ' ----- Given an object, assume it is an ItemData instance.
        '       Convert it and return the numeric value. Return -1 on failure.
        Dim itemDataVersion As ItemData

        If (whichRecord Is Nothing) Then Return -1&
        If Not (TypeOf (whichRecord) Is ItemData) Then Return -1&

        ' ----- Convert and extract.
        itemDataVersion = CType(whichRecord, ItemData)
        Return itemDataVersion.ItemValue
    End Function
End Class
