﻿' ----- Microsoft ADO.NET 4.0 Step by Step
'       Sample for Chapter 19 - Visual Basic Version
'       by Tim Patrick

Imports System.Data.Objects.SqlClient
Imports System.Data.Objects.DataClasses

Public Class StatesByYear
    Private Sub StatesByYear_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ----- Perform the lookup.
        Using context As New SalesOrderEntities(GetConnectionString())
            Dim result = From st In context.StateRegions
                     Select StateName = st.FullName,
                     AdmitYear = SqlFunctions.DatePart("year", st.Admitted),
                     TotalAdmittedInYear = AdmittedInYear(st.Admitted)
                     Order By AdmitYear

            StateAdmittance.DataSource = result.ToList
        End Using
    End Sub

    <EdmFunction("SalesOrderModel.Store", "AdmittedInYear")>
    Public Shared Function AdmittedInYear(ByVal whichDate As Date?) As Integer?
        ' ----- This is a stub for the true AdmittedInYear function in the database.
        Throw New NotSupportedException("Direct calls are not supported.")
    End Function
End Class
