﻿' ----- Microsoft ADO.NET 4.0 Step by Step
'       Sample for Chapter 2 - Visual Basic Version
'       by Tim Patrick

Public Class Switchboard
    Private Sub ActNoColumns_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActNoColumns.Click
        ' ----- Show a table with no columns.
        Dim theTable As DataTable

        theTable = GetNoColumnTable()
        If (theTable Is Nothing) Then Return
        ShowTable(theTable)
    End Sub

    Private Sub ActColumns_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActColumns.Click
        ' ----- Show a table with data columns.
        Dim theTable As DataTable

        theTable = GetColumnTable()
        If (theTable Is Nothing) Then Return
        ShowTable(theTable)
    End Sub

    Private Sub ActDesigner_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActDesigner.Click
        ' ----- Show a table created in the Dataset Designer.
        Dim theTable As DataTable

        theTable = GetDesignerTable()
        If (theTable Is Nothing) Then Return
        ShowTable(theTable)
    End Sub

    Private Function GetNoColumnTable() As DataTable
        ' ----- Return a table that has no columns.
        Return New DataTable("BoringTable")
    End Function

    Private Function GetColumnTable() As DataTable
        ' ----- Return a table that has columns.
        Dim theTable As New DataTable("Customer")

        ' ----- Add some basic columns.
        theTable.Columns.Add("ID", GetType(Long))
        theTable.Columns.Add("FullName", GetType(String))
        theTable.Columns.Add("LastOrderDate", GetType(Date))

        ' ----- Create a primary key for the table.
        theTable.PrimaryKey = {theTable.Columns("ID")}

        ' ----- Finished.
        Return theTable
    End Function

    Private Function GetDesignerTable() As DataTable
        ' ----- Return a table created in the Dataset Designer.
        Return New ExternalTable.CustomerDataTable
    End Function

    Private Sub ShowTable(ByVal whichTable As DataTable)
        ' ----- Show the design of a table through the detail form.
        If (whichTable Is Nothing) Then Return
        Call (New TableDetails).ShowTable(whichTable)
    End Sub
End Class
