﻿' ----- Microsoft ADO.NET 4.0 Step by Step
'       Sample for Chapter 5 - Visual Basic Version
'       by Tim Patrick

Public Class FlightDetail
    Public Function EditDetail(ByRef flightRow As DataRow) As Boolean
        ' ----- Fill in the existing details.
        If (IsDBNull(flightRow!ID) = False) Then _
            FlightID.Value = CInt(flightRow!ID)
        If (IsDBNull(flightRow!Region) = False) Then _
            RegionName.Text = CStr(flightRow!Region)
        If (IsDBNull(flightRow!FlightsPerWeek) = False) Then _
            FlightsPerWeek.Value = CInt(flightRow!FlightsPerWeek)

        ' ----- Prompt the user for the changes.
        If (Me.ShowDialog() = DialogResult.OK) Then
            Try
                flightRow.BeginEdit()
                flightRow!ID = FlightID.Value
                flightRow!Region = RegionName.Text.Trim
                flightRow!FlightsPerWeek = FlightsPerWeek.Value
                flightRow.EndEdit()
            Catch ex As Exception
                MessageBox.Show("Changes could not be saved: " & ex.Message)
                Return False
            End Try
            Return True
        Else
            Return False
        End If
    End Function

    Private Sub TextFields_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles RegionName.Enter
        ' ----- Highlight the entire text.
        CType(sender, TextBox).SelectAll()
    End Sub

    Private Sub ActOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActOK.Click
        ' ----- The region name is required.
        If (RegionName.Text.Trim.Length = 0) Then
            MessageBox.Show("Please provide a region name.")
            RegionName.Focus()
            Return
        End If

        ' ----- Success.
        Me.DialogResult = DialogResult.OK
    End Sub
End Class