﻿' ----- Microsoft ADO.NET 4.0 Step by Step
'       Sample for Chapter 9 - Visual Basic Version
'       by Tim Patrick

Imports System.Data.SqlClient

Module General
    Public Function DBText(ByVal origText As String) As String
        ' ----- Prepare a text string for use in a SQL statement.
        If (origText Is Nothing) Or (origText.Length = 0) Then
            Return "NULL"
        Else
            Return "'" & Replace(origText, "'", "''") & "'"
        End If
    End Function

    Public Sub ExecuteSQL(ByVal sqlText As String,
            ByVal linkToDB As SqlConnection)
        ' ----- Execute a SQL statement with no expected return values.
        Try
            Dim commandWrapper As New SqlCommand(sqlText, linkToDB)
            commandWrapper.ExecuteNonQuery()
        Catch ex As Exception
            MessageBox.Show("Database non-query failed: " & ex.Message)
        End Try
    End Sub

    Public Function ExecuteSQLReturn(ByVal sqlText As String,
            ByVal linkToDB As SqlConnection) As Object
        ' ----- Execute a SQL statement with a scalar return value.
        Try
            Dim commandWrapper As New SqlCommand(sqlText, linkToDB)
            Return commandWrapper.ExecuteScalar()
        Catch ex As Exception
            MessageBox.Show("Database scalar query failed: " & ex.Message)
            Return Nothing
        End Try
    End Function

    Public Function GetConnectionString() As String
        ' ----- Build a connection string for the active database.
        Dim builder As New SqlConnectionStringBuilder

        builder.DataSource = "(local)\SQLExpress"
        builder.InitialCatalog = "StepSample"
        builder.IntegratedSecurity = True
        Return builder.ConnectionString
    End Function

    Public Function OpenConnection() As SqlConnection
        ' ----- Open a connection to the database.
        Try
            Dim linkToDB As New SqlConnection(GetConnectionString())
            linkToDB.Open()
            Return linkToDB
        Catch ex As Exception
            MessageBox.Show("Database connection failed: " & ex.Message)
            Return Nothing
        End Try
    End Function

    Public Function OpenReader(ByVal sqlText As String,
            ByVal linkToDB As SqlConnection) As SqlDataReader
        ' ----- Open a DataReader for the given SQL statement.
        Try
            Dim commandWrapper As New SqlCommand(sqlText, linkToDB)
            Return commandWrapper.ExecuteReader()
        Catch ex As Exception
            MessageBox.Show("Database query failed: " & ex.Message)
            Return Nothing
        End Try
    End Function
End Module
