﻿' ----- Microsoft ADO.NET 4.0 Step by Step
'       Sample for Chapter 10 - Visual Basic Version
'       by Tim Patrick

Imports System.Data.SqlClient

Public Class ViewOrders
    ' ----- Local information store of customer orders.
    Private Class OrderInfo
        Public ID As Long
        Public OrderDate As Date
        Public OrderTotal As Decimal
    End Class

    Private ActiveCustomerID As Long

    Public Sub ShowOrders(ByVal whichCustomer As Long)
        ' ----- Display the orders for a customer.
        ActiveCustomerID = whichCustomer
        Me.ShowDialog()
    End Sub

    Private Sub ViewOrders_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ----- Prepare the form.
        Dim sqlText As String
        Dim commandWrapper As SqlCommand
        Dim customerReader As SqlDataReader = Nothing
        Dim oneOrder As OrderInfo

        ' ----- Retrieve the customer data.
        Using linkToDB As SqlConnection = OpenConnection()
            Try
                ' ----- Process the query. The GetCustomerOrders stored procedure
                '       returns to sets of records, one for the customer and one
                '       for the orders.

                ' ----- First read the customer record.

                ' ----- Read the next set, which contains the orders.

            Catch ex As Exception
                MessageBox.Show("Error occurred accessing order data: " & ex.Message)
                Return
            Finally
                If (customerReader IsNot Nothing) Then customerReader.Close()
            End Try
        End Using
    End Sub

    Private Sub AllOrders_DrawItem(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawItemEventArgs) Handles AllOrders.DrawItem
        ' ----- Draw a single display item.
        Dim useBrush As System.Drawing.Brush
        Dim itemDetail As OrderInfo

        ' ----- Ignore undrawable items.
        If (e.Index = -1) Then Return

        ' ----- Draw the background of the item.
        If (CBool(CInt(e.State) And CInt(DrawItemState.Selected))) _
            Then useBrush = SystemBrushes.HighlightText _
            Else useBrush = SystemBrushes.WindowText
        e.DrawBackground()

        ' ----- Extract the detail from the list.
        itemDetail = CType(AllOrders.Items(e.Index), OrderInfo)

        ' ----- Draw the text of the item.
        e.Graphics.DrawString(CStr(itemDetail.ID), e.Font, useBrush, 0, e.Bounds.Top)
        e.Graphics.DrawString(Format(itemDetail.OrderDate, "M/d/yyyy"),
            e.Font, useBrush, ColOrderDate.Left - ColOrderID.Left, e.Bounds.Top)
        e.Graphics.DrawString(Format(itemDetail.OrderTotal, "Currency"),
            e.Font, useBrush, ColOrderTotal.Left - ColOrderID.Left, e.Bounds.Top)

        ' ----- If the ListBox has focus, draw a focus rectangle.
        e.DrawFocusRectangle()
    End Sub
End Class