﻿' ----- Microsoft ADO.NET 4.0 Step by Step
'       Sample for Chapter 2 - Visual Basic Version
'       by Tim Patrick

Public Class TableDetails
    Private ActiveTable As DataTable

    Public Sub ShowTable(ByVal whichTable As DataTable)
        ' ----- Show the form to the user.
        ActiveTable = whichTable
        Me.ShowDialog()
    End Sub

    Private Sub TableDetails_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' ----- If there's no table, jump out early.
        If (ActiveTable Is Nothing) OrElse (ActiveTable.TableName Is Nothing) OrElse
                (ActiveTable.TableName.Length = 0) OrElse
                (ActiveTable.Columns Is Nothing) Then
            AllColumns.Items.Add("No columns available")
            Return
        End If

        ' ----- Show the table name.

        ' ----- Add the columns to the display list.

    End Sub

    Private Sub AllColumns_DrawItem(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawItemEventArgs) Handles AllColumns.DrawItem
        ' ----- Draw a single display item.
        Dim useBrush As System.Drawing.Brush
        Dim itemDetail As DataColumn
        Dim ellipsesFormat As StringFormat
        Dim columnName As String = ""
        Dim dataTypeName As String = ""
        Dim isPrimaryKey As Boolean = False

        ' ----- Ignore undrawable items.
        If (e.Index = -1) Then Return

        ' ----- Draw the background of the item.
        If (CBool(CInt(e.State) And CInt(DrawItemState.Selected))) _
            Then useBrush = SystemBrushes.HighlightText _
            Else useBrush = SystemBrushes.WindowText
        e.DrawBackground()

        ' ----- This list handles both DataColumn and string entries.
        If (TypeOf AllColumns.Items(e.Index) Is DataColumn) Then
            ' ----- Extract the detail from the list.
            itemDetail = CType(AllColumns.Items(e.Index), DataColumn)

            ' ----- Extract the column details.

            ' ----- Some data may not fit.
            ellipsesFormat = New StringFormat
            ellipsesFormat.Trimming = StringTrimming.EllipsisCharacter

            ' ----- Draw the text of the item.
            e.Graphics.DrawString(columnName, e.Font, useBrush,
                New Rectangle(ColColumnName.Left - AllColumns.Left,
                e.Bounds.Top, ColDataType.Left - ColColumnName.Left - 5,
                e.Bounds.Height), ellipsesFormat)
            e.Graphics.DrawString(dataTypeName, e.Font, useBrush,
                ColDataType.Left - AllColumns.Left, e.Bounds.Top)

            ' ----- Indicate if this is a primary key column.
            If (isPrimaryKey) Then
                e.Graphics.DrawString("PK", e.Font, useBrush, 0, e.Bounds.Top)
            End If
        Else
            ' ----- Display the string content.
            e.Graphics.DrawString(CStr(AllColumns.Items(e.Index)),
                e.Font, useBrush, 0, e.Bounds.Top)
        End If

        ' ----- If the ListBox has focus, draw a focus rectangle.
        e.DrawFocusRectangle()
    End Sub
End Class