﻿' ----- Microsoft ADO.NET 4.0 Step by Step
'       Sample for Chapter 5 - Visual Basic Version
'       by Tim Patrick

Public Class LegDetail
    Public Function EditDetail(ByRef legRow As DataRow, ByVal trueFlightID As String) As Boolean
        ' ----- Fill in the existing details.
        If (trueFlightID.Length > 0) Then ParentFlightID.Text = trueFlightID
        If (IsDBNull(legRow!FlightID) = False) Then _
            FlightID.Value = CInt(legRow!FlightID)
        If (IsDBNull(legRow!StartCity) = False) Then _
            StartCity.Text = CStr(legRow!StartCity)
        If (IsDBNull(legRow!EndCity) = False) Then _
            EndCity.Text = CStr(legRow!EndCity)
        If (IsDBNull(legRow!Distance) = False) Then _
            FlightDistance.Value = CInt(legRow!Distance)

        ' ----- Prompt the user for the changes.
        If (Me.ShowDialog() = DialogResult.OK) Then
            Try
                legRow.BeginEdit()
                legRow!FlightID = FlightID.Value
                legRow!StartCity = StartCity.Text.Trim
                legRow!EndCity = EndCity.Text.Trim
                legRow!Distance = FlightDistance.Value
                legRow.EndEdit()
            Catch ex As Exception
                MessageBox.Show("Changes could not be saved: " & ex.Message)
                Return False
            End Try
            Return True
        Else
            Return False
        End If
    End Function

    Private Sub TextFields_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles _
            StartCity.Enter, EndCity.Enter
        ' ----- Highlight the entire text.
        CType(sender, TextBox).SelectAll()
    End Sub

    Private Sub ActOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActOK.Click
        ' ----- The start city is required.
        If (StartCity.Text.Trim.Length = 0) Then
            MessageBox.Show("Please provide a start city.")
            StartCity.Focus()
            Return
        End If

        ' ----- The end city is required.
        If (EndCity.Text.Trim.Length = 0) Then
            MessageBox.Show("Please provide an end city.")
            EndCity.Focus()
            Return
        End If

        ' ----- The cities can't be the same.
        If (StartCity.Text.Trim.ToUpper = EndCity.Text.Trim.ToUpper) Then
            MessageBox.Show("The start and end cities must be different.")
            EndCity.Focus()
            Return
        End If

        ' ----- Success.
        Me.DialogResult = DialogResult.OK
    End Sub
End Class